using System;
using System.Drawing;
using System.Drawing.Drawing2D;

namespace TestProject
{
    /// <summary>
    /// Ʈ 
    /// </summary>
    [Serializable]
    public class StripInfo
    {
        //////////////////////////////////////////////////////////////////////////////////////////////////// Field
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region Field

        /// <summary>
        /// Ʈ 迭
        /// </summary>
        public int[][] StripArray { get; private set; }

        /// <summary>
        /// ʺ
        /// </summary>
        public int Width { get; private set; }

        /// <summary>
        /// 
        /// </summary>
        public int Height { get; private set; }

        /// <summary>
        /// 
        /// </summary>
        public float Scale { get; private set; }

        /// <summary>
        /// ҽ ʺ
        /// </summary>
        public int SourceWidth { get; private set; }

        /// <summary>
        /// ҽ 
        /// </summary>
        public int SourceHeight { get; private set; }

        /// <summary>
        ///  
        /// </summary>
        public bool IsVertical { get; private set; }

        /// <summary>
        /// ִ 
        /// </summary>
        public const int MAXIMUM_HEIGHT = 600;

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Constructor
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region  - StripInfo(sourceBitmap, stripCount, isVertical)

        /// <summary>
        /// 
        /// </summary>
        /// <param name="sourceBitmap">ҽ Ʈ</param>
        /// <param name="stripCount">Ʈ īƮ</param>
        /// <param name="isVertical"> </param>
        public StripInfo(Bitmap sourceBitmap, int stripCount, bool isVertical = false)
        {
            SourceWidth  = sourceBitmap.Width;
            SourceHeight = sourceBitmap.Height;
            IsVertical   = isVertical;

            Scale = SourceHeight > MAXIMUM_HEIGHT ? 1f * MAXIMUM_HEIGHT / SourceHeight : 1f;

            Width  = stripCount;
            Height = (int)((IsVertical ? SourceWidth : SourceHeight) * Scale);

            int targetWidth  = isVertical ? Height : Width;
            int targetHeight = isVertical ? Width  : Height;

            using(Bitmap targetBitmap = new Bitmap(targetWidth, targetHeight))
            {
                using(Graphics targetGraphics = Graphics.FromImage(targetBitmap))
                {
                    targetGraphics.InterpolationMode = InterpolationMode.Low;

                    targetGraphics.DrawImage(sourceBitmap, 0, 0, targetWidth, targetHeight);

                    using(BitmapWrapper bitmapWrapper = new BitmapWrapper(targetBitmap, true))
                    {
                        StripArray = new int[Width][];

                        for(int x = 0; x < StripArray.Length; x++)
                        {
                            int[] stripHeightArray = StripArray[x] = new int[Height];

                            if(isVertical)
                            {
                                for(int y = 0; y < stripHeightArray.Length; y++)
                                {
                                    stripHeightArray[y] = bitmapWrapper[y, x].G;
                                }
                            }
                            else
                            {
                                for(int y = 0; y < stripHeightArray.Length; y++)
                                {
                                    stripHeightArray[y] = bitmapWrapper[x, y].G;
                                }
                            }
                        }
                    }
                }
            }
        }

        #endregion
    }
}